using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp3
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] nq = Console.ReadLine().Split();
            int n = int.Parse(nq[0]); int q = int.Parse(nq[1]);
            string[] ulaz = Console.ReadLine().Split();
            int[] a = new int[n];  List<int> b = new List<int>();
            for (int i = 0; i < n; i++)
            {
                a[i] = int.Parse(ulaz[i]);
            }
            for (int i2 = 0; i2 < q; i2++)
            {
                int max_duzina = 1;
                string[] lr = Console.ReadLine().Split();
                int l = int.Parse(lr[0]); int r = int.Parse(lr[1]);
                List<int> lista_lr = new List<int>(); int duzina = 0;
                for (int i3 = l-1; i3 < r; i3++) 
                {
                    if (!lista_lr.Contains(a[i3]))
                    {
                        lista_lr.Add(a[i3]);
                    }
                }
                for (int i = 0; i < lista_lr.Count; i++) 
                {
                    HashSet<int> set = new HashSet<int>();
                    duzina = 0;
                    for (int j = 0; j < lista_lr.Count; j++) 
                    {
                        if (i == j) 
                        {
                            continue;
                        }
                        if ((lista_lr[i] & lista_lr[j]) > (lista_lr[i] ^ lista_lr[j]))
                        {
                            set.Add(lista_lr[j]);
                        }
                    }
                    if (set.Count > 0) 
                    {
                        set.Add(lista_lr[i]);
                        for (int i3 = l - 1; i3 < r; i3++)
                        {
                            if (set.Contains(a[i3]))
                            {
                                duzina++;
                            }
                        }
                    }
                    if(duzina > max_duzina)
                    {
                        max_duzina = duzina;
                    }
                }
                b.Add(max_duzina);
            }
            foreach(int x in b)
            {
                Console.WriteLine(x);
            }
        }
    }
}